# 开发j-spring的Npm包

> j-spring的npm包只能j-spring框架使用.  

## 1.脚手架创建demo-hello项目
> 使用j-spring-cli 脚手架,自动创建npm包项目结构,还会自动创建markdown文档.

```shell

> npm instal j-spring-cli -g
> j-spring-cli
  3.j-spring-npm #选择3创建Npm包

> please enter a java Bean name. example: HelloWorldBean
 demoHello #这里需要使用驼峰格式来创建项目名

 #运行一边吧,测试项目结构正常.
 Building complish!
 1.cd demo-hello
 2.npm install
 3.node index.js
```

## 2.demo-hello包结构
```shell
├─demo-hello
│  ├─demo
│  ├─resource
│  └─spring_extends
│      └─bean
│      └─index.js
│--inex.js
```

- demo 测试文件目录
- resource 测试配置目录
- spring_extends/bean 需要扫描的源码目录,只存放需要扫描的js文件源码.
- spring_extends/index.js 包真正对外暴漏的引用文件
- index.js 包的测试启动文件

## 3.解析spring_extends/index.js文件
```js
const path = require("path")
const {DemoHello} = require("./bean/DemoHello")



//1.创建一个包加载器 暴漏包名和源码位置集合.
const DemoHelloScaner =  (packageName='demo-hello')=> {
	return [
			{
				packageName,
				srcList:[path.join(__dirname,"./bean")]
			}
		]
};

//2.对外暴漏引用 包加载器和Bean的class
module.exports = {
	DemoHelloScaner,
	DemoHello
}

```

##  4.引用其它j-spring的npm包
> 假设在demo-hello中添加j-spring-sqlite3-jdbc包

```js
const path = require("path")
const {DemoHello} = require("./bean/DemoHello")
//引用其它的j-spring包
const {JSpringSqlite3JdbcScaner} = require('j-spring-sqlite3-jdbc')


//1.创建一个包加载器 暴漏包名和源码位置集合.
const DemoHelloScaner =  (packageName='demo-hello')=> {
	return [
			{
				packageName,
				srcList:[path.join(__dirname,"./bean")]
			},
      JSpringSqlite3JdbcScaner //只要在这里添加加载器即可.其它不变
		]
};

//2.对外暴漏引用 包加载器和Bean的class
module.exports = {
	DemoHelloScaner,
	DemoHello
}
```

## 5.引用demo-hello 项目
> 启动配置moduleList中加上demo-hello的包加载器即可. 容器就会自动解析包内所有的Bean了.

```js
const {SpringBoot} = require("j-spring")
const {DemoHelloScaner} = require("demo-hello")

new SpringBoot({
  ...,
	moduleList:[DemoHelloScaner] ;//输入扫描器
})

```

## 6.参考项目
> SpringMvc的j-spring版本.

[j-spring-mvc](https://gitee.com/woaianqi/j-spring-mvc)
